using System;
using System.Collections.Generic;
using System.Text;
using gehtsoft.indicore;

namespace ApplyStrategy
{
    class MyIndicatorTickSource : IndicatorTickSource
    {
        public MyIndicatorTickSource() { }
        public MyIndicatorTickSource(bool bIsBid, string strInstr)
        {
            setInstrument(strInstr);
            setBid(bIsBid);
            setPrecision(5);
            setPipSize(0.0001);
        }
        private List<tickData> myData = new List<tickData>();
        private int precision = 4;
        private double pipSize = 0.01;
        private string instrument;

        public struct tickData
        {
            public int serial;
            public DateTime dt;
            public double tickVal;
        }
        private int mSerial = 0;
        private bool bBid = true;

        public override string getName()
        {
            return "tickName";
        }
        public override int size()
        {
            return myData.Count;
        }
        public override bool isBar()
        {
            return false;
        }
        public override bool hasData(int index)
        {
            if (index >= myData.Count)
                return false;
            else
                return true;
        }
        public override bool supportsVolume()
        {
            return false;
        }
        public void setInstrument(string instrument)
        {
            this.instrument = instrument;
        }
        public override string getInstrument()
        {
            return instrument;
        }
        public override int getSerial(int index)
        {
            return myData[index].serial;
        }
        public void setPipSize(double pipSize)
        {
            this.pipSize = pipSize;
        }
        public override double getPipSize()
        {
            return pipSize;
        }
        public void AddLast(System.DateTime dt, double val)
        {
            tickData td;
            td.serial = ++mSerial;
            td.dt = dt;
            td.tickVal = val;
            myData.Add(td);
        }
        public void AddLastTicks(MyIndicatorTickSource lastTicks)
        {
            List<tickData> addedData = lastTicks.myData;
            foreach (tickData td in addedData)
            {
                AddLast(td.dt, td.tickVal);
            }
        }
        public override double getTick(int index)
        {
            tickData tickD = myData[index];
            double tick = tickD.tickVal;
            return tick;
        }
        public DateTime getDate(int index)
        {
            DateTime dt = myData[index].dt;
            return dt;
        }
        public override bool isBid()
        {
            return bBid;
        }
        public void setBid(bool bIsBid)
        {
            this.bBid = bIsBid;
        }
        public override bool isAlive()
        {
            return true;
        }
        public void setPrecision(int precision)
        {
            this.precision = precision;
        }
        public override int getPrecision()
        {
            return precision;
        }
        public override int getDisplayPrecision()
        {
            return precision;
        }
        public override int getFirstPeriod()
        {
            return 0;
        }
        public override DateTime date(int index)
        {
            return myData[index].dt;
        }
    }
}
