using System;
using System.Collections.Generic;
using System.Text;
using gehtsoft.indicore;

namespace ApplyStrategy
{
    class Ticket
    { // this class holds information for price stream used by strategy
        private MyIndicatorTickSource tickBuffer;    // buffer to keep ticks from the moment of calling "GetPriceHistory" until price history would be completed (add ticks to the end of the stream at that point)
        public MyIndicatorTickSource TickBuffer
        {
            get { return tickBuffer; }
        }
        private IndicatorSource src;                 // stream itself
        public IndicatorSource Src
        {
            get { return src; }
        }
        private bool bHistCompleted = false;         //Stream already filled with prices (stream is empty for for asynchronous history price request until the event "OnPriceHistoryCompleted")
        public bool HistCompleted
        {
            get { return bHistCompleted; }
            set { bHistCompleted = value; }
        }
        private string sHistRequest = string.Empty;          //Request id for asynchronous GetPriceHistoryAsync method (to be used in TradeDeskEventsSink.OnPriceHistoryCompleted)
        public string HistRequest
        {
            get { return sHistRequest; }
        }
        private int iCookie = 0;                   //Asynchronous operation cookie (to be passed to AsyncOperationFinished function of the strategy when data is loaded)
        public int Cookie
        {
            get { return iCookie; }
        }
        private bool bTillNow = true;              //Price stream keeps prices up to "now" => add new ticks to this stream
        public bool TillNow
        {
            get { return bTillNow; }
        }
        public Ticket(IndicatorSource src, bool bHistCompleted, string sHistRequest, int iCookie, bool bTillNow)
        {
            this.src = src;
            this.bHistCompleted = bHistCompleted;
            this.sHistRequest = sHistRequest;
            this.iCookie = iCookie;
            this.bTillNow = bTillNow;
            if (src.isBid())
                tickBuffer = new MyIndicatorTickSource(true, src.getInstrument());
            else
                tickBuffer = new MyIndicatorTickSource(false, src.getInstrument());
        }
    }
}
