using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;

namespace ApplyStrategy
{
    class TimersMgr                                                 //The class is used only by some strategies using "setTimer" and "killTimer"
    {
        static List<TimerInfo> timersInfo = new List<TimerInfo>(); // some strategies have "setTimer" command - keep information about timers
        static int iLastTimerID = 1000;                            // each timer should have unique ID
        public static int AddTimer(int iCookie, int iTimeoutSeconds) // Set and start the timer for 'host:execute("setTimer", cookie, timeout)'
        {
            iLastTimerID++;
            Timer aTimer = new Timer();
            aTimer.Interval = iTimeoutSeconds * 1000; // in milliseconds
            aTimer.Enabled = true;
            aTimer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            TimerInfo timerInfo = new TimerInfo(aTimer, iLastTimerID, iCookie);
            timersInfo.Add(timerInfo);
            return iLastTimerID;
        }
        public static void KillTimer(int iTimerID)                  // Stop the timer which was started earlier (command 'host:execute("killTimer", timerid)')
        {
            foreach (TimerInfo timerInfo in timersInfo)             // find Timer in a list
            {
                int iThisTimerID = timerInfo.TimerID;
                if (iThisTimerID == iTimerID)
                {
                    Timer timer = timerInfo.TimerItself;
                    timer.Stop();                                  // Stop the Timer
                    break;
                }
            }
        }
        static void timer_Elapsed(object sender, ElapsedEventArgs e) // notify strategy when (after timer was set) "timer elapsed" event happens
        {
            foreach (TimerInfo timerInfo in timersInfo)                  // find Timer in a list
            {
                Timer timer = timerInfo.TimerItself;
                if (sender == timer)                                     // Timer found
                {
                    int iCookie = timerInfo.Cookie;
                    string sNotifyError;
                    Program.Instance.notifyFinished(iCookie, true, "", out sNotifyError);
                    if (!string.IsNullOrEmpty(sNotifyError))
                        Console.WriteLine("Error on \"notifyFinished\": {0}", sNotifyError);
                    break;
                }
            }
        }

    }
}
